C - Halloween Costumes (区间概率的模板)

Gappu has a very busy weekend ahead of him. Because, next weekend is Halloween, and he is planning to attend as many parties as he can. Since it’s Halloween, these parties are all costume parties, Gappu always selects his costumes in such a way that it blends with his friends, that is, when he is attending the party, arranged by his comic-book-fan friends, he will go with the costume of Superman, but when the party is arranged contest-buddies, he would go with the costume of ‘Chinese Postman’.

Since he is going to attend a number of parties on the Halloween night, and wear costumes accordingly, he will be changing his costumes a number of times. So, to make things a little easier, he may put on costumes one over another (that is he may wear the uniform for the postman, over the superman costume). Before each party he can take off some of the costumes, or wear a new one. That is, if he is wearing the Postman uniform over the Superman costume, and wants to go to a party in Superman costume, he can take off the Postman uniform, or he can wear a new Superman uniform. But, keep in mind that, Gappu doesn’t like to wear dresses without cleaning them first, so, after taking off the Postman uniform, he cannot use that again in the Halloween night, if he needs the Postman costume again, he will have to use a new one. He can take off any number of costumes, and if he takes off k of the costumes, that will be the last k ones (e.g. if he wears costume A before costume B, to take off A, first he has to remove B).

Given the parties and the costumes, find the minimum number of costumes Gappu will need in the Halloween night.

Input
Input starts with an integer T (≤ 200), denoting the number of test cases.

Each case starts with a line containing an integer N (1 ≤ N ≤ 100) denoting the number of parties. Next line contains N integers, where the ith integer ci (1 ≤ ci ≤ 100) denotes the costume he will be wearing in party i. He will attend party 1 first, then party 2, and so on.

Output
For each case, print the case number and the minimum number of required costumes.

Sample Input
2

4

1 2 1 2

7

1 2 1 1 3 2 1

Sample Output
Case 1: 3

Case 2: 4

题目大意:如何身体相当于一个栈,如何用最少的衣服,来完成例题中的序列。

思路:这是比较典型的区间DP,区间DP一般是0(n^3)的复杂度,一般第一成循环是用来枚举区间的长度的,而第二成循环用来枚举区间的起点的,而第三成循环一般是用来将小区间用于合并成大区间,一般模板如下:

memset(dp,0,sizeof(dp))//初始dp数组
for(int len=2;len<=n;len++){//枚举区间长度
    for(int i=1;i<n;++i){//枚举区间的起点
        int j=i+len-1;//根据起点和长度得出终点
        if(j>n) break;//符合条件的终点
        for(int k=i;k<=j;k++)//枚举最优分割点
            dp[i][j]=min(dp[i][j],dp[i][k]+dp[k+1][j]+w[i][j]);//状态转移方程
    }
}
         
        

完整的代码如下:

#include <cstdio>
#include <iostream>
#include <cstring>
#include <algorithm>
#include <string>
#include <set>
#include <cmath>
using namespace std;
const int maxn = 200010;
const int maxn2= 110;
const int inf =0x3f3f3f3f;
const int mod = 10007;
int s[maxn2];
int dp[maxn2][maxn2];
int t,n;
int main()
{
    scanf("%d",&t);
    for(int w=1;w<=t;w++){
        scanf("%d",&n);
        for(int i=1;i<=n;i++){
            scanf("%d",&s[i]);
        }
        memset(dp,inf,sizeof(dp));
        for(int i=1;i<=n;i++)dp[i][i]=1;
        for(int i=1;i<n;i++){
            for(int j=1;j+i<=n;j++){
                int l=j+i;
                if(s[j]!=s[l]) dp[j][l]=min(dp[j+1][l]+1,dp[j][l-1]+1);
                else dp[j][l]=min(dp[j+1][l],dp[j][l-1]);
                for(int k=j;k<l;k++){
                    dp[j][l]=min(dp[j][l],dp[j][k]+dp[k+1][l]);
                }
            }
        }
        printf("Case %d: %d\n",w,dp[1][n]);
    }
    return 0;
}

发布了35 篇原创文章 · 获赞 25 · 访问量 819

猜你喜欢

转载自blog.csdn.net/qq_43816599/article/details/103863488